<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    public function up(): void {
        Schema::create('status_histories', function (Blueprint $table)
        {
            $table->id();

            $table->foreignId('solicitor_id')->nullable()
                ->constrained()
                ->cascadeOnDelete();

            $table->morphs('subject');
            $table->foreignId('status_id')->constrained();

            $table->timestamp('started_at');
            $table->timestamp('ended_at')->nullable();

            $table->foreignId('changed_by')->nullable()
                ->constrained('users')
                ->nullOnDelete();

            $table->timestamps();

            $table->index(['status_id', 'started_at']);
        });
    }

    public function down(): void {
        Schema::dropIfExists('status_histories');
    }
};
